#include "adc.h"


/**********************************************************************************
	ADC fuggvenyek
***********************************************************************************/

//Az AD konvertalas inicializalasa
void ADC_init(void) {
  unsigned int test_conversion;
  
  //A MUXn bitekkel allitjuk be az ADC csatornat
  ADMUX |= _BV(MUX0) | _BV(MUX1);
  ADMUX |= (1 << REFS0) /*| (1 << REFS1)*/;//belso AVcc hasznalatanak engedelyezese
    
  //Az ADC engedelyezese es frekvencia osztasanak beallitasa, 8 MHz / 128 = 62.5 kHz    
  ADCSRA |= (1 << ADEN);
  ADCSRA |= (1 << ADPS0) | (1 << ADPS1) | (1 << ADPS2);

  ADCSRA &= ~_BV(ADFR);//ADATE at90can128-nal, ADFR atmega128-nal,Egyetlen egy konverzio, jobbra igazitas  

  //Egyetlen egy beolvasast vegzunk, hogy a tobbi konvertalas pontos es gyorsabb legyen
  test_conversion = ADC_read();       
}


//Az AD konvertalas elinditasa
int ADC_read(void) {
  unsigned char i;
  int ADC_temp;
  unsigned int ADCr = 0;
    
  ADCSRA |= _BV(ADEN);     //Engedelyezzuk az ADC-t

  //Egy beolvasast vegzunk
  ADCSRA |= (1 << ADSC);        //Egyetlen atalakitas
  while(!(ADCSRA & (1 << ADIF)));    //Varakozunk mig a konverzio befejezodik, az ADIF jelzobit aktiv
        
  for (i=0;i<8;i++)            //8-szor vegezzuk az ADC atalakitast, hogy pontosabb eredmenyt kapjunk 
  {
     ADCSRA |= (1 << ADSC);        //Egyetlen konverziot csinalunk
     while(!(ADCSRA & (1 << ADIF)));    //Varunk mig az atalakitas be nem fejezodik. Az ADIF flag aktiv
        
     ADC_temp = ADCL;            //Kiolvassuk az ADCL regisztert
     ADC_temp |= (ADCH << 8);    //Kiolvassuk az ADCH regisztert        

     ADCr += ADC_temp;      //Az eredmeny (8 minta alapjan) osszegyujtese a tovabbi atlagolashoz
  }

  ADCr = ADCr >> 3;     //8 minta kozeperteke
        
  ADCSRA &= ~_BV(ADEN); //Letiltjuk az ADC-t

  return ADCr;
}



/**********************************************************************************
	Voltmero 
***********************************************************************************/
//Feszultsegleolvaso fuggveny
void getVolt(void) {
  char volt[6];
  unsigned int ADCresult = 0;

  ADCresult = ADC_read();
  
  //Egy valos valtozot sztringge alakitjuk at
  dtostrf(3.26 * ADCresult / 1024, 5, 3, volt);	

  //A PC-be kuldjuk a feszultseg erteket
  sendString("A beolvasas eredmenye: \r");
  sendString("Feszultseg: ");
	sendString(volt);
  sendString(" volt.\r");
	
	sendString("Homerseklet: ");
	dtostrf(3.26 * 100 * ADCresult / 1023, 5, 1, volt);
	sendString(volt);
 	sendString(" oC.\r");
}
